package com.xy.service;

import com.xy.entity.MercFeeConfigAlgorithmType;
import com.xy.mapper.MercFeeConfigAlgorithmTypeMapper;
import com.xy.service.MercFeeConfigAlgorithmTypeService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;

import java.util.List;
import com.xy.utils.R;
import com.xy.utils.PageBean;
import com.xy.dto.MercFeeConfigAlgorithmTypeDto;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.PostMapping;
import io.swagger.annotations.ApiOperation;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.xy.utils.MybatisPlusQuery;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springframework.validation.annotation.Validated;
import com.xy.utils.Emptys;

import static com.xy.utils.Beans.copy;
import static com.xy.utils.PlusBeans.toIPage;
import static com.xy.utils.PlusBeans.toPageBean;


/**
* <p>
* 商户算法扣费标准配置扩展 服务实现类
* </p>
*
* @author 谭斌
* @since 2024-04-07
*/
@Service
@AllArgsConstructor
@Api(tags = "商户算法扣费标准配置扩展")
public class MercFeeConfigAlgorithmTypeServiceImpl extends ServiceImpl<MercFeeConfigAlgorithmTypeMapper, MercFeeConfigAlgorithmType> implements MercFeeConfigAlgorithmTypeService {

    @PostMapping("obj")
    @ApiOperation("对象查询")
    public R<MercFeeConfigAlgorithmTypeDto.Vo> obj(@RequestBody MercFeeConfigAlgorithmTypeDto.Vo vo) {
        MercFeeConfigAlgorithmTypeDto.SelectList selectList = copy(MercFeeConfigAlgorithmTypeDto.SelectList.class, vo);
        List<MercFeeConfigAlgorithmTypeDto.Vo> list = list(selectList).getData();
        if(Emptys.check(list)) {
            return R.ok(list.get(0));
        }
        return R.ok();
    }

    @PostMapping("list")
    @ApiOperation("集合查询")
    public R<List<MercFeeConfigAlgorithmTypeDto.Vo>> list(@RequestBody MercFeeConfigAlgorithmTypeDto.SelectList selectList) {
        LambdaQueryWrapper<MercFeeConfigAlgorithmType> lambdaQueryWrapper = new MybatisPlusQuery().eqWrapper(selectList, MercFeeConfigAlgorithmType.class).build();
        List<MercFeeConfigAlgorithmType> list = list(lambdaQueryWrapper);
        return R.ok(copy(MercFeeConfigAlgorithmTypeDto.Vo.class, list));
    }

    @PostMapping("page")
    @ApiOperation("分页查询")
    public R<PageBean<MercFeeConfigAlgorithmTypeDto.Vo>> page(@RequestBody MercFeeConfigAlgorithmTypeDto.Page page) {
        PageBean pageBean = page.getPage();
        LambdaQueryWrapper<MercFeeConfigAlgorithmType> lambdaQueryWrapper = new MybatisPlusQuery().eqWrapper(page, MercFeeConfigAlgorithmType.class).build();
        IPage<MercFeeConfigAlgorithmType> iPage = page(toIPage(pageBean), lambdaQueryWrapper);
        return R.ok(toPageBean(MercFeeConfigAlgorithmTypeDto.Vo.class, iPage));
    }

    @PostMapping("save")
    @ApiOperation("添加")
    public R save(@RequestBody @Validated MercFeeConfigAlgorithmTypeDto.Save save) {
        MercFeeConfigAlgorithmType saveInfo = copy(MercFeeConfigAlgorithmType.class, save);
        save(saveInfo);
        return R.ok();
    }

    @PostMapping("update")
    @ApiOperation("修改")
    public R update(@RequestBody @Validated MercFeeConfigAlgorithmTypeDto.Update update) {
        MercFeeConfigAlgorithmType updateInfo = copy(MercFeeConfigAlgorithmType.class, update);
        updateById(updateInfo);
        return R.ok();
    }
}