package com.xy.service;

import com.xy.entity.MercFeeConfigDevice;
import com.xy.mapper.MercFeeConfigDeviceMapper;
import com.xy.service.MercFeeConfigDeviceService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;

import java.util.List;
import com.xy.utils.R;
import com.xy.utils.PageBean;
import com.xy.dto.MercFeeConfigDeviceDto;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.PostMapping;
import io.swagger.annotations.ApiOperation;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.xy.utils.MybatisPlusQuery;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springframework.validation.annotation.Validated;
import com.xy.utils.Emptys;

import static com.xy.utils.Beans.copy;
import static com.xy.utils.PlusBeans.toIPage;
import static com.xy.utils.PlusBeans.toPageBean;


/**
* <p>
* 商户设备管理费配置扩展 服务实现类
* </p>
*
* @author 谭斌
* @since 2024-04-07
*/
@Service
@AllArgsConstructor
@Api(tags = "商户设备管理费配置扩展")
public class MercFeeConfigDeviceServiceImpl extends ServiceImpl<MercFeeConfigDeviceMapper, MercFeeConfigDevice> implements MercFeeConfigDeviceService {

    @PostMapping("obj")
    @ApiOperation("对象查询")
    public R<MercFeeConfigDeviceDto.Vo> obj(@RequestBody MercFeeConfigDeviceDto.Vo vo) {
        MercFeeConfigDeviceDto.SelectList selectList = copy(MercFeeConfigDeviceDto.SelectList.class, vo);
        List<MercFeeConfigDeviceDto.Vo> list = list(selectList).getData();
        if(Emptys.check(list)) {
            return R.ok(list.get(0));
        }
        return R.ok();
    }

    @PostMapping("list")
    @ApiOperation("集合查询")
    public R<List<MercFeeConfigDeviceDto.Vo>> list(@RequestBody MercFeeConfigDeviceDto.SelectList selectList) {
        LambdaQueryWrapper<MercFeeConfigDevice> lambdaQueryWrapper = new MybatisPlusQuery().eqWrapper(selectList, MercFeeConfigDevice.class).build();
        List<MercFeeConfigDevice> list = list(lambdaQueryWrapper);
        return R.ok(copy(MercFeeConfigDeviceDto.Vo.class, list));
    }

    @PostMapping("page")
    @ApiOperation("分页查询")
    public R<PageBean<MercFeeConfigDeviceDto.Vo>> page(@RequestBody MercFeeConfigDeviceDto.Page page) {
        PageBean pageBean = page.getPage();
        LambdaQueryWrapper<MercFeeConfigDevice> lambdaQueryWrapper = new MybatisPlusQuery().eqWrapper(page, MercFeeConfigDevice.class).build();
        IPage<MercFeeConfigDevice> iPage = page(toIPage(pageBean), lambdaQueryWrapper);
        return R.ok(toPageBean(MercFeeConfigDeviceDto.Vo.class, iPage));
    }

    @PostMapping("save")
    @ApiOperation("添加")
    public R save(@RequestBody @Validated MercFeeConfigDeviceDto.Save save) {
        MercFeeConfigDevice saveInfo = copy(MercFeeConfigDevice.class, save);
        save(saveInfo);
        return R.ok();
    }

    @PostMapping("update")
    @ApiOperation("修改")
    public R update(@RequestBody @Validated MercFeeConfigDeviceDto.Update update) {
        MercFeeConfigDevice updateInfo = copy(MercFeeConfigDevice.class, update);
        updateById(updateInfo);
        return R.ok();
    }
}